+++
title = "プレゼン動画を事前録画するときのtips"
date = 2021-05-30T15:10:34+09:00
description = "アナウンサーの人、カメラ目線で原稿読んでいて、尊敬します。"
categories = ["雑記", "ガジェット"]
author = "kazu634"
images = ["ogp/2021-05-30-record-presentation-using-powerpoint.webp"]
tags = ["プレゼン"]
+++

5月はお仕事関係で2つプレゼン動画を作成する必要があり、必要に迫られて動画作成をしていました。そこで得たtipsをまとめたいと思います。

## この記事のターゲット
ウェビナーなどで発表するための動画を事前録画して用意する必要がある方向けの記事です。

## 動画を作成する方法のまとめ
会社のPCに入っているソフトだけで動画を作成する方法を探すと、主に二つ方法がありました。

1. Microsoft PowerPointを利用する方法
2. Microsoft Teamsを利用する方法

ここではMicrosoft PowerPointを利用していきますよ。

## まずはここ読んで
まずはここを読んでほしいです: [パワーポイント標準機能だけで顔出し技術セッションの動画を作る - Qiita](https://qiita.com/okazuki/items/f184c4af44e3fff9fae8)。

## 色々と学んだtipsとか
ここから学んだtipsをまとめていきます。

### 撮影準備編
- PC内臓のマイクは360度音を拾うようになっているため、例えば遠くの換気扇などの音も拾うようになっています。これだと不要な音が入り込むため、マイクの前に座っている人の声だけを拾うマイクを使った方が音質が良くなる。私は自費で[これ](https://www.amazon.co.jp/Blue-Microphones-Snowball-BM200BK-2%E5%B9%B4%E9%96%93%E3%83%A1%E3%83%BC%E3%82%AB%E3%83%BC%E4%BF%9D%E8%A8%BC/dp/B0822PSXCN)を買いました。
- 後ほど説明しますが、動画編集ソフトがあると、色々と便利です。例えば、デモ動画は別な人が録画して、声だけ録音したい…といったケースでは動画編集ソフトが大活躍します。デモ動画をn倍で再生して、目当ての時間内で再生させて、そこに声を当てるといったことができるようになります。

### 録画・録音編
- 顔出し動画をリクエストされるケースがありますが、顔出しは最初と最後の一部のスライドだけに止めるのがいいです。完全に個人の意思で動画作成を完了できるのであればいいのですが、会社組織に所属している場合は、色々と指摘を受けて修正するケースが多いと思います。撮り直そうとした場合、翌日着ている服が変わると全部撮り直しになります。。
- 顔出しをするときはカメラをまっすぐ見たいところですが、何話すか忘れがちです。カメラの向こうとかに原稿を置いとくなど工夫が必要かも。アナウンサーの人、カメラ目線で原稿読んでいて、尊敬します。
- 次に何を話すか真っ白になったら、とりあえず「えー」とか「あー」とかで間をつなぐのではなくて、黙った方がいいです。後で、動画ソフトで音声が入っていない部分を削除ししまえばいいだけです。「えー」とか「あー」とか音声が入っていると、逆に動画編集が難しくなってしまいます。
- 上のように書きましたが、後工程の編集作業を楽にするためには、音声はできるだけスムーズに話したほうが編集が楽になります。指摘を受けて、動画を修正する必要が出てきた場合、動画編集ソフトで音声を詰める作業をもう一度やり直すことになるので。。
- Microsoft PowerPointはスライド単位で録音します。特定のスライドだけ録音しなおしたい場合には、録音中に次のスライドに切り替えると次のスライドの音声も上書きされてしまいます。間違えて切り替えないようにしましょう。
- 上とも関連するのですが、PowerPointでポインターを表示させて、わかりやすくプレゼンする場合がほとんどだと思います。その場合は、録音を停止させるためにポインターを移動して、録音停止させる必要が出てきますが、音声を取り終わってすぐにポインターを移動させると違和感ありまくりです。無音で3秒程度待ってから、ポインターを移動させて、録音停止させましょう。後で、無音部分は動画編集ソフトで削除してしまいましょう。

### 動画編集編
- 動画編集ソフトの基本的な使い方は覚えておくといいです。選択範囲のトリミング、音声を0にする、音声を追加する、n倍速にする…くらいができるといいです。

## まとめ
プレゼン動画を事前録画するときのtipsをまとめてみました。何かの参考になれば幸いです。

<hr>
<div class="krb-amzlt-box" style="margin-bottom:0px;"><div class="krb-amzlt-image" style="float:left;margin:0px 12px 1px 0px;"><a href="https://www.amazon.co.jp/Blue-Microphones-Snowball-BM200BK-2%E5%B9%B4%E9%96%93%E3%83%A1%E3%83%BC%E3%82%AB%E3%83%BC%E4%BF%9D%E8%A8%BC/dp/B0822PSXCN?&linkCode=li2&tag=simsnes-22&linkId=fba85280bb9f3b5e62202d5bdb707fd2&ref_=as_li_ss_il" target="_blank" rel="nofollow" rel="nofollow"><img border="0" src="//ws-fe.amazon-adsystem.com/widgets/q?_encoding=UTF8&ASIN=B0822PSXCN&Format= _SL250_&ID=AsinImage&MarketPlace=JP&ServiceVersion=20070822&WS=1&tag=simsnes-22" ></a><img src="https://ir-jp.amazon-adsystem.com/e/ir?t=simsnes-22&l=li2&o=9&a=B0822PSXCN" width="1" height="1" border="0" alt="" style="border:none !important; margin:0px !important;" /></div><div class="krb-amzlt-info" style="line-height:120%; margin-bottom: 10px"><div class="krb-amzlt-name" style="margin-bottom:10px;line-height:120%"><a href="https://www.amazon.co.jp/Blue-Microphones-Snowball-BM200BK-2%E5%B9%B4%E9%96%93%E3%83%A1%E3%83%BC%E3%82%AB%E3%83%BC%E4%BF%9D%E8%A8%BC/dp/B0822PSXCN?&linkCode=li2&tag=simsnes-22&linkId=fba85280bb9f3b5e62202d5bdb707fd2&ref_=as_li_ss_il" name="amazletlink" target="_blank" rel="nofollow" rel="nofollow">Blue Microphones Snowball iCE USB コンデンサー マイク Black スノーボール アイス ブラック BM200BK PC MAC PS4 USB ストリーミング 配信 ストリーマー テレワーク web会議 国内正規品 2年間メーカー保証</a><div class="krb-amzlt-powered-date" style="font-size:80%;margin-top:5px;line-height:120%">posted with <a href="https://kaereba.com/wind/" title="amazlet" target="_blank" rel="nofollow" rel="nofollow">カエレバ</a></div></div><div class="krb-amzlt-detail"></div><div class="krb-amzlt-sub-info" style="float: left;"><div class="krb-amzlt-link" style="margin-top: 5px"><a href="https://www.amazon.co.jp/Blue-Microphones-Snowball-BM200BK-2%E5%B9%B4%E9%96%93%E3%83%A1%E3%83%BC%E3%82%AB%E3%83%BC%E4%BF%9D%E8%A8%BC/dp/B0822PSXCN?&linkCode=li2&tag=simsnes-22&linkId=fba85280bb9f3b5e62202d5bdb707fd2&ref_=as_li_ss_il" name="amazletlink" target="_blank" rel="nofollow" rel="nofollow">Amazon.co.jpで詳細を見る</a></div></div></div><div class="krb-amzlt-footer" style="clear: left"></div></div>
